#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofBackground(255,255,255);
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	
	mark = 1;

	
	
}

//--------------------------------------------------------------
void testApp::update(){
	
	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
	}
	
	
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].addDampingForce();
		particles[i].update();
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	
	
	ofSetColor(0,0, 255);
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].draw();
	}
	
	
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	switch (key){
			
		case ' ':
			// reposition everything: 
			for (int i = 0; i < particles.size(); i++){
				particles[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
			}
			break;
	}
	
	
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

	
	for (int i = 0; i < particles.size(); i++){
		particles[i].addRepulsionForce(particles[i], 200, 0.1);
		particles[i].addCounterClockwiseForce(particles[i], 80, 0.09);
		
		
		for (int j = 0; j < i; j++){
			
			particles[j].addAttractionForce(mouseX, mouseY, 1000, 0.1f);
		}
		particles[i].update();
	}
	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	
	if (mark == 1){
	for (int i = 0; i < 300; i++){
		particle myParticle;
		myParticle.setInitialCondition(x+ ofRandom(0, 50),y+ ofRandom(0, 50),0,0);
		particles.push_back(myParticle);
		mark = 0;
	}
	}
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
